// TODO
/* bug报告: 
 *	1 当在地图上添加了小图标后,放在再移动地图,那么即使松开鼠标左键,地图还会跟着光标移动
 *      此时若单击地图,小图标的位置会发生偏移.
 *  2  步行线路api给得太粗.第一,点数太少;第二,没有步行长度
 */

var globalRedirect;
var globalBusRoutes;
var globalData;
var scrollbar;
var routeType = "mostFast";
var globalPaths = {};

//颜色设置
var busColor = "#8600FF";
var walkColor = "#00DB00";

var globalBusLineDetails;
var globalBusLineStation;
var globalBusTransMessage=[];
var globalIsAuto = false;

var size = new SuperMap.Size(30, 32);
var offset = new SuperMap.Pixel(-(size.w/2), -size.h);
var iconstart = new SuperMap.Icon("../images/supermap/start_poi.png", size, offset);
var iconend = new SuperMap.Icon("../images/supermap/end_poi.png", size, offset);

var noStart = false, noEnd = false, isStartKey = false, isEndKey = false,
styleLine = {
strokeColor: "blue",
strokeWidth: 3,
strokeLinecap: "round",
strokeDashstyle: "solid"
},
busStyleLine = {
strokeColor: "#8600FF",
strokeWidth: 3,
strokeLinecap: "round",
strokeDashstyle: "solid"
},
walkStyleLine = {
strokeColor: "#00DB00",
strokeWidth: 3,
strokeLinecap: "round",
strokeDashstyle: "solid"
},
styleLineRed = {
strokeColor: "red",
strokeWidth: 4,
strokeLinecap: "round",
strokeDashstyle: "solid"
};

//var traffic_transfer = "http://59.56.174.147:8090/iserver/services/trafficTransferAnalyst-HaiKou/restjsr/traffictransferanalyst/transferNetwork-haikou";
var traffic_transfer = "http://124.225.110.155:8090/iserver/services/trafficTransferAnalyst-HaiKou/restjsr/traffictransferanalyst/transferNetwork-haikou";

/*
 * MAP对象，实现MAP功能
 *
 * 接口：
 * size()     获取MAP元素个数
 * isEmpty()    判断MAP是否为空
 * clear()     删除MAP所有元素
 * put(key, value)   向MAP中增加元素（key, value) 
 * remove(key)    删除指定KEY的元素，成功返回True，失败返回False
 * get(key)    获取指定KEY的元素值VALUE，失败返回NULL
 * element(index)   获取指定索引的元素（使用element.key，element.value获取KEY和VALUE），失败返回NULL
 * containsKey(key)  判断MAP中是否含有指定KEY的元素
 * containsValue(value) 判断MAP中是否含有指定VALUE的元素
 * values()    获取MAP中所有VALUE的数组（ARRAY）
 * keys()     获取MAP中所有KEY的数组（ARRAY）
 *
 * 例子：
 * var map = new Map();
 *
 * map.put("key", "value");
 * var val = map.get("key")
 * ……
 *
 */
function Map() {
    this.elements = new Array();
 
    //获取MAP元素个数
    this.size = function() {
        return this.elements.length;
    }
 
    //判断MAP是否为空
    this.isEmpty = function() {
        return (this.elements.length < 1);
    }
 
    //删除MAP所有元素
    this.clear = function() {
        this.elements = new Array();
    }
 
    //向MAP中增加元素（key, value) 
    this.put = function(_key, _value) {
        this.elements.push( {
            key : _key,
            value : _value
        });
    }
 
    //删除指定KEY的元素，成功返回True，失败返回False
    this.remove = function(_key) {
        var bln = false;
        try {
            for (i = 0; i < this.elements.length; i++) {
                if (this.elements[i].key == _key) {
                    this.elements.splice(i, 1);
                    return true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    }
 
    //获取指定KEY的元素值VALUE，失败返回NULL
    this.get = function(_key) {
        try {
            for (i = 0; i < this.elements.length; i++) {
                if (this.elements[i].key == _key) {
                    return this.elements[i].value;
                }
            }
        } catch (e) {
            return null;
        }
    }
 
    //获取指定索引的元素（使用element.key，element.value获取KEY和VALUE），失败返回NULL
    this.element = function(_index) {
        if (_index < 0 || _index >= this.elements.length) {
            return null;
        }
        return this.elements[_index];
    }
 
    //判断MAP中是否含有指定KEY的元素
    this.containsKey = function(_key) {
        var bln = false;
        try {
            for (i = 0; i < this.elements.length; i++) {
                if (this.elements[i].key == _key) {
                    bln = true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    }
 
    //判断MAP中是否含有指定VALUE的元素
    this.containsValue = function(_value) {
        var bln = false;
        try {
            for (i = 0; i < this.elements.length; i++) {
                if (this.elements[i].value == _value) {
                    bln = true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    }
 
    //获取MAP中所有VALUE的数组（ARRAY）
    this.values = function() {
        var arr = new Array();
        for (i = 0; i < this.elements.length; i++) {
            arr.push(this.elements[i].value);
        }
        return arr;
    }
 
    //获取MAP中所有KEY的数组（ARRAY）
    this.keys = function() {
        var arr = new Array();
        for (i = 0; i < this.elements.length; i++) {
            arr.push(this.elements[i].key);
        }
        return arr;
    }
}


function addLine(lineArray, style, color, width, name, detail) { // 创建折线函数。
	var busline=new SuperMap.Geometry.LineString(lineArray);
	var feature = new SuperMap.Feature.Vector(busline);
	feature.style = style;
	vectorLayer.addFeatures(feature);
}

function fixHeight(percent)  
{  
    return window.screen.availHeight*percent; //这里你可以自己做调整  
}

/**
 * 根据一组点的经纬度字符串数组,在地图上画一个公交线路
 */
function drawBusRoute(strArray) {
	// 在起始位置和终点位置打上一个车子的标志
	var startPoi = strArray[0].toString().split(",");
	myicon = new MMarker (
		  new MPoint(startPoi[0], startPoi[1]),
		  new MIcon("../images/supermap/bus.png", 21, 21) // 配置标注点显示图标。
		);
	maplet.addOverlay(myicon);
	
	var endPoi = strArray[strArray.length - 1].toString().split(",");
	myicon = new MMarker (
		  new MPoint(endPoi[0], endPoi[1]),
		  new MIcon("../images/supermap/bus.png", 21, 21) // 配置标注点显示图标。
		);
	maplet.addOverlay(myicon);
	
	if (strArray.length > 0) {
		// 将折点存入数组。
		var lineArray = new Array(strArray.length);
		for (var i = 0; i < strArray.length; i++) {
			lineArray[i] = new MPoint(strArray[i]);
		}
		addLine(lineArray, 0, "#8600FF", 5, "", ""); // 创建1个折线。
	}
}

/**
 * 根据一组点的经纬度字符串数组,在地图上画一个步行线路
 */
function drawWalkRoute(strArray) {
	if (strArray.length > 0) {
		// 将折点存入数组。
		var lineArray = new Array(strArray.length);
		for (var i = 0; i < strArray.length; i++) {
			lineArray[i] = new MPoint(strArray[i]);
		}
		addLine(lineArray, 0, "#00DB00", 4, "", ""); // 创建1个折线。
	}
}

/**
 * 根据一组点的经纬度字符串数组,在地图上画一条公交线路
 */
function drawBusLine(strArray) {
	if (strArray.length > 0) {
		// 将折点存入数组。
		var lineArray = new Array(strArray.length);
		for (var i = 0; i < strArray.length; i++) {
		    if(strArray[i]!=""){
		    var lon=strArray[i].split(",")[0];
		    var lat=strArray[i].split(",")[1];
			lineArray[i] = new SuperMap.Geometry.Point(lon,lat).transform("EPSG:4326","EPSG:3857");;
			}
		}
		addLine(lineArray, busStyleLine, "#4E79DD", 6, "", ""); // 创建1个折线。
	}
}

/**
 * 在地图上显示起点与终点的图标
 */
function drawStartEndMarker() {
	var pois = globalData.pois;
	var pngs = ["start_poi.png", "end_poi.png"];
	
	for (var pos in pois) {
		var poi = pois[pos];
		myicon = new MMarker (
			  new MPoint(poi.lat,poi.lon),
			  new MIcon("../images/supermap/" + pngs[pos], 30, 32) // 配置标注点显示图标。
			);
		maplet.addOverlay(myicon);
	}
}


/**
*公交换乘方案中点击某个线路编号跳转到相应的线路查询中
*/
function tobusRoute(lineNo){
	lineNo=lineNo.match(/\d+/)+'';
	var url = "bus_route!search.action?lineName=" + lineNo + "&redirect=busRoute";
	window.open(url)
}

/**
*公交换乘方案中点击站点跳转到相应的站点查询中
*/
function toStation(stationName){
	var url = "bus_route!search.action?stationName=" +  encodeURI(encodeURI(stationName)) + "&redirect=busRoute";
	window.open(url)
}
function clickaFristRoute(){
	   var pos=0;
	   var busRoute = globalBusRoutes[pos];
		// ("应家塘;120.21648,30.3474","闸弄口新村;120.19874,30.27227")
		var stationPoisList = busRoute.stationPois;
		var startStation = stationPoisList[0][0].name; // 第一个站点名称
		
		var lastLineStations = stationPoisList[stationPoisList.length - 1]; // 最后一次转车路线经过的站点
		var endStation = lastLineStations[lastLineStations.length - 1].name;
		// 展开路线详情
		var detailHtmlHead = 
              '<tr class="detail">' +
              '  <td align="center" class="bk3"><img src="../images/supermap/qi.png" width="19" height="23"></td>' +
              '  <td height="35" class="bk3"><span class="STYLE8">' + globalData.startPoi.name + '&nbsp;<input type="button" value="发送短信" id="sendSms" pos="' + pos + '">&nbsp;<input type="button" value="添加收藏" id="addFavorite" pos="' + pos + '"></span></td>' +
              '</tr>' +
              '<tr class="detail">' +
              '  <td align="center" class="bk3" ><img src="../images/supermap/icon2.gif" width="18" height="21"></td>' +
              '  <td height="35" class="bk3" >步行到 <span class="STYLE3" onclick="toStation('+'&quot;'+startStation+'&quot;'+')">' + startStation + '站</span>　　　　　　　　　　　<span class="STYLE7"></span><br>' +
              '    </td>' +
              '</tr>';
              
		var detailHtmlBody = "";
		var preLineLastStation = ""; // 上一次转车路线的最后一个站点
        for (var i = 0; i < stationPoisList.length; i ++) {
        	var stationPois = stationPoisList[i];
        	var firstStation = stationPois[0].name;
        	var lastStation = stationPois[stationPois.length - 1].name;
        	var lineName = busRoute.lineDetails[i];
        	var stationCount = stationPois.length;
        	
        	if (preLineLastStation != firstStation && preLineLastStation != "") { // 如果上次转车的最后一站不是现在的第一站,说明需要步行到站点
	        	detailHtmlBody += 
					  '<tr class="detail">' +
		              '  <td align="center" class="bk3" ><img src="../images/supermap/icon2.gif" width="18" height="21"></td>' +
		              '  <td height="35" class="bk3" >步行到 <span class="STYLE3" onclick="toStation('+'&quot;'+firstStation+'&quot;'+')">' + firstStation + '站</span>　　　　　　　　　　　<span class="STYLE7"></span><br>' +
		              '    </td>' +
		              '</tr>';
        	}
        	
        	detailHtmlBody += 
	              '<tr class="detail">' +
	              '  <td align="center" class="bk3"><img src="../images/supermap/icon3.gif" width="16" height="18"></td>' +
	              '  <td height="35" class="bk3">乘坐 <span class="STYLE5"  onclick="tobusRoute('+'&quot;'+lineName+'&quot;'+')">' + lineName + '</span>,到 <span class="STYLE3" onclick="toStation('+'&quot;'+lastStation+'&quot;'+')">' + lastStation + '站</span> 下车　　　&nbsp;<span class="STYLE7">经' + stationCount + '站</span></td>' +
	              '</tr>';
	        preLineLastStation = lastStation;
        }
          
		var detailHtmlFoot = 
			  '<tr class="detail">' +
              '  <td align="center" class="bk3" ><img src="../images/supermap/icon2.gif" width="18" height="21"></td>' +
              '  <td height="35" class="bk3" >步行到 <span class="STYLE3" onclick="toStation('+'&quot;'+globalData.endPoi.name+'&quot;'+')">' + globalData.endPoi.name + '</span>　　　　　　　　　　　<span class="STYLE7"></span><br>' +
              '    </td>' +
              '</tr>' +
              '<tr class="detail">' +
              '  <td align="center" bgcolor="#F0F5FB"><img src="../images/supermap/zhong.png" width="18" height="23"></td>' +
              '  <td height="35" bgcolor="#F0F5FB"><span class="STYLE8" onclick="toStation('+'&quot;'+globalData.endPoi.name+'&quot;'+')">' + globalData.endPoi.name + '</span></td>' +
              '</tr>';
              
        var detailHtml = detailHtmlHead + detailHtmlBody + detailHtmlFoot;
        //$(this).children().first().append(detailHtml);
        $(".routeTable:first").children().first().append(detailHtml);
        // 清除地图上已有折线等叠加物
		maplet.clearOverlays(); 
		clearOverLays();
		
		
		// 将地图显示为相应的中心和缩放
		maplet.setCenter(new MPoint(busRoute.routeCenter));
		maplet.setZoomLevel(busRoute.routeZoom);
		
		// 显示起点与终点
		drawStartEndMarker();
		
		// 在地图上显示这个线路所对应的公交路线
		for (var i in busRoute.routeLatlons) {
			var str = busRoute.routeLatlons[i].toString();
			var strArray = str.split(";");
			drawBusRoute(strArray);
		}
		
		// 在地图上显示这个线路所对应的步行路线
		for (var i in busRoute.walkRouteDetails) {
			var str = busRoute.walkRouteDetails[i].routeLatlon.toString();
			var strArray = str.split(";");
			drawWalkRoute(strArray);
		}

		//scrollbar.tinyscrollbar_update(parseInt(pos) * 93);
		
}

/**
 * 根据路线的类型查询公交线路
 */
function searchBusRoutesFunc() {
	mapClear();
	var startName = $("#startName").val();
	var endName = $("#endName").val();
	if (startName == "我在哪儿") {
		alert("请输入我在哪儿!");
		return;
	}
	if (endName == "我要去哪儿") {
		alert("请输入我要去哪儿!");
		return;
	}
	$(".busRoutes").remove();
	if(routeType == "mostFast"){//最快到达
	  var lonlatStr=getStartEndStopLonlat();
	  //console.log(lonlatStr);
	  eval("var stopIDs = [" +lonlatStr+"];");
	  if(stopIDs) {
		//executeTrafficTransfer(stopIDs, SuperMap.REST.TransferTactic.LESS_TIME);
		executeTrafficTransfer(stopIDs, SuperMap.REST.TransferTactic.LESS_TRANSFER);
	  }
	}
	if(routeType == "leastChange"){//最小换乘
	  //var stopIDs = getStartEndStopID();
	   var lonlatStr=getStartEndStopLonlat();
	  eval("var stopIDs = [" +lonlatStr+"];");
	  if(stopIDs) {
		executeTrafficTransfer(stopIDs, SuperMap.REST.TransferTactic.LESS_TRANSFER);
	  }
	}
	if(routeType == "leastWalk"){//最小步行
		//var stopIDs = getStartEndStopID();
		 var lonlatStr=getStartEndStopLonlat();
	     eval("var stopIDs = [" +lonlatStr+"];");
		if(stopIDs) {
		//executeTrafficTransfer(stopIDs, SuperMap.REST.TransferTactic.LESS_WALK);
		executeTrafficTransfer(stopIDs, SuperMap.REST.TransferTactic.LESS_TRANSFER);
		}
	}
	
}

/**
 * 根据路线的名称查询公交线路站点
 */
function searchBusLinesFunc() {
	mapClear();
	var lineName = $("#lineName").val();
	$("#showBusRoutes").html("");
	$.ajax({
				url : "bus_route!ajaxSearchLineDetails.action",
				type : "post",
				dataType : "json",
				contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
				data : {
					lineName : lineName
				},
				success : function(data) {
					var busLineDetails = data.busLineDetails;
					globalBusLineDetails = busLineDetails;
					
					var count = busLineDetails.length;
					var busLineDetailsHtml = "";
					if(count!=0){
					for (var i = 0; i < count; i ++) {
//						busLineDetailsHtml +=
//							'<tr class="busLine" pos="' + i + '" id="busLine' + i + '">' +
//							'	<td class="busLineDetailList" align="left">' +
//							'		<a href="#" class="plus" id="abusLine'+i+'" style="color:#47cdf9"><img src="../images/supermap/plus.png" /> ' +busLineDetails[i].name + '</a>' +
//							'	</td>' +
//							'</tr>';
							
							 busLineDetailsHtml +=
							        '<tr class="busLine" pos="' + i + '" id="busLine' + i + '">' +
							        '    <td align="center" >' +
							        '        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="bk6" id="' + i + '">' +
							        '            <tr class="bk5" style= "cursor:pointer;" >' +
							        '                <td width="35" height="50" align="center" class="bk4" style="padding-bottom:25px">' +
							        '                    <img src="../images/supermap/icon' + (i + 1) + '.png" width="19" height="18" />' +
							        '                    <input type="hidden" id="unfold'+i+'"  class="plus" />' +
							        '                </td>' +
							        '                <td class="bk4" style="padding-bottom:10px">' +
							        '                    <span class="STYLE9" style="line-height:250%">' + busLineDetails[i].name + '</span>' +
							        '                    <br>' +
					                '                    <span class="STYLE10">首末车时间:'+busLineDetails[i].origTime+'-'+busLineDetails[i].destTime+'|</span><span class="STYLE10">票价：'+busLineDetails[i].carFare + '元</span>' +
							        '                </td>' +
							        '            </tr>' +
							        '        </table>' +
							        '    </td>' +
							        ' </tr>' +
							        ' <tr class="busRoutes" >' +
							        '    <td align="center">' +
							        '        &nbsp;' +
							        '    </td>' +
							        ' </tr>';
							
							
							
							
					}
					}else{
						busLineDetailsHtml +=
					        '<div>'+
							'<div style="background-color:#38B0DE;font-weight:bold;" align="right">共0条记录&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>'+
							'<div align="center">在<span style="font-weight:bold;">海口市</span>范围内未找到相关线路，抱歉。</div>'+
							'</div>';
					}    
					$("#showBusRoutes").append(busLineDetailsHtml);
					scrollbar = $('#scrollbar');
					scrollbar.tinyscrollbar();
					$("#scrollbar .viewport").css({"height" : $(window).height() - 288});
					scrollbar.tinyscrollbar_update();
					
					mapClear();

					
				}
			});
}
	
/**
 * 【站点查询】根据站点的名称查询经过该站点的所有线路
 */
function searchBusStationsFunc() {
	mapClear();
	var stationName = $("#stationName").val();
	$("#showBusRoutes").html("");
	$.ajax({
				url : "bus_route!ajaxSearchLineInfos.action",
				type : "post",
				dataType : "json",
				contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
				data : {
					station : stationName
				},
				success : function(data) {
					var busLineDetails = data.busLineDetails;
					globalBusLineDetails = busLineDetails;
					
					var count = busLineDetails.length;
					var busLineDetailsHtml = "";
					if(count!=0){
					for (var i = 0; i < count; i ++) {
//						busLineDetailsHtml +=
//							'<tr class="busLine" pos="' + i + '" id="busLine' + i + '">' +
//							'	<td class="busLineDetailList" align="left">' +
//							'		<a href="#" class="plus" id="abusLine'+i+'" style="color:#47cdf9"><img src="../images/supermap/plus.png" /> ' +busLineDetails[i].name + '</a>' +
//							'	</td>' +
//							'</tr>';
							
							 busLineDetailsHtml +=
							        '<tr class="busLine" pos="' + i + '" id="busLine' + i + '">' +
							        '    <td align="center" >' +
							        '        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="bk6" id="' + i + '">' +
							        '            <tr class="bk5" style= "cursor:pointer;" >' +
							        '                <td width="35" height="50" align="center" class="bk4" style="padding-bottom:25px">' +
							        '                    <img src="../images/supermap/icon' + (i + 1) + '.png" width="19" height="18" />' +
							        '                    <input type="hidden" id="unfold'+i+'"  class="plus" />' +
							        '                </td>' +
							        '                <td class="bk4" style="padding-bottom:10px">' +
							        '                    <span class="STYLE9" style="line-height:250%">' + busLineDetails[i].name + '</span>' +
							        '                    <br>' +
					                '                    <span class="STYLE10">首末车时间:'+busLineDetails[i].origTime+'-'+busLineDetails[i].destTime+'|</span><span class="STYLE10">票价：'+busLineDetails[i].carFare + '元</span>' +
							        '                </td>' +
							        '            </tr>' +
							        '        </table>' +
							        '    </td>' +
							        ' </tr>' +
							        ' <tr class="busRoutes" >' +
							        '    <td align="center">' +
							        '        &nbsp;' +
							        '    </td>' +
							        ' </tr>';
							
							
							
							
					}
					}else{
						busLineDetailsHtml +=
					        '<div>'+
							'<div style="background-color:#38B0DE;font-weight:bold;" align="right">共0条记录&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>'+
							'<div align="center">在<span style="font-weight:bold;">海口市</span>范围内未找到相关线路，抱歉。</div>'+
							'</div>';
					}    
					$("#showBusRoutes").append(busLineDetailsHtml);
					scrollbar = $('#scrollbar');
					scrollbar.tinyscrollbar();
					$("#scrollbar .viewport").css({"height" : $(window).height() - 288});
					scrollbar.tinyscrollbar_update();
					mapClear();
				}
			});
}

/**
 * 清空页面
 */
function clearPage() {
	$("#startName").val("");
	$("#endName").val("");
	
	$(".detail").empty();
	$(".busRoutes").remove();
	
	maplet.clearOverlays();
	clearOverLays();
	
}

function setTopleftscrollbar(){
	var height= $("#topleft").css("height")
	var windowWidth=document.documentElement.clientWidth
	var windowHeight=document.documentElement.clientHeight
    $("#topleftscrollbar").css("height","'"+(height.substring(0,height.length-2))/windowHeight+"'");
}


function findStartStopsOld(startName) {
	mapClear();
	if(isStartKey) return;
    markerlayer.clearMarkers();
	startLayer.clearMarkers();
	vectorLayer.removeAllFeatures();
    var nameList=new Array();
	var list=$("#qidian");
	list.empty();;
	
	var params = new SuperMap.REST.StopQueryParameters({
	keyWord: startName,
	returnPosition: true
	});
	var iserver = new SuperMap.REST.StopQueryService(traffic_transfer, {
	eventListeners: {
	processCompleted: stopQuerySucceed,
	processFailed: stopQueryFailed
	}
	});
	iserver.processAsync(params);
	//返回根据模糊的地名搜索得到的跟地名有关的所有公交站点的结果
	function stopQuerySucceed(stopQueryEvent) {
	if(!stopQueryEvent.result.transferStopInfos.length) {
	$("<li>未找到匹配的站点</li>").appendTo(list);
	noStart = true;
	}else {
	noStart = false;
		for(var i=0,len=stopQueryEvent.result.transferStopInfos.length; i<len; i++) {
			var station = stopQueryEvent.result.transferStopInfos[i];
			var value = station.stopID+","+station.position.x+","+station.position.y;
		    list.css("display","block");
			$("<li id='" + value + "'>" + station.name + "</li>").appendTo(list); 
			
			list.find("li").click(function() {
				var input = $("#startName");
				input.val($(this).text());
				input.attr("text", $(this).attr("id"));
				$("#qidian").empty();
				list.css("display","none");
				var arr = $(this).attr("id").split(",");
				startLayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(arr[1], arr[2]), iconstart));
				maplet.setCenter(new SuperMap.LonLat(arr[1], arr[2]), 4);
				});
		}
	}
	}
	function stopQueryFailed(result) {
	  alert(result);
	}
	return nameList;
}

function findStartStops(startName) {
	mapClear();
	if(isStartKey) return;
    markerlayer.clearMarkers();
	startLayer.clearMarkers();
	vectorLayer.removeAllFeatures();
    var nameList=new Array();
	var list=$("#qidian");
	list.empty();
	
	var queryParam = new SuperMap.REST.FilterParameter({
                    name:"QueryData@海口",
                    attributeFilter: "NAME like  '%"+startName+"%' "
                  });
    var  queryBySQLParams = new SuperMap.REST.QueryBySQLParameters({
        expectCount:10,
        queryParams: [queryParam]
    });
    
    var queryBySQLService = new SuperMap.REST.QueryBySQLService(url, {
                    eventListeners: {"processCompleted": processCompleted, "processFailed": processFailed}});
    queryBySQLService.processAsync(queryBySQLParams);
    
	//返回根据模糊的地名搜索得到的跟地名有关的所有公交站点的结果
	function processCompleted(queryEventArgs) {
	            var i, j, feature,labelFeas = [],label,
                        result = queryEventArgs.result;
                if (result && result.recordsets) {
                    var totalnum=result.currentCount;
                    if(totalnum==0){
                       $("<li>未找到匹配的站点</li>").appendTo(list);
	                   noStart = true;
                    }else{
                        noStart = false;
	                    var pois=new Array(); 
	                    for (i=0; i<result.recordsets.length; i++) {
	                        if (result.recordsets[i].features) {
	                            for (j=0; j<result.recordsets[i].features.length; j++) {
	                               feature = result.recordsets[i].features[j];
	                               pois.push(feature);
	                               var point = feature.geometry;
	                               var icon=getMarkerIcon();
								   var smId=feature.attributes.SmID;
								   var poiName=feature.attributes.NAME;
								   var poiAddress=feature.attributes.ADDRESS;
								   var lon=feature.attributes.SmX;
								   var lat=feature.attributes.SmY;
								   var value = smId+","+lon+","+lat;
								   list.css("display","block");
								   $("<li id='" + value + "'>" + poiName + "</li>").appendTo(list); 
								   list.find("li").click(function() {
									var input = $("#startName");
									input.val($(this).text());
									input.attr("text", $(this).attr("id"));
									$("#qidian").empty();
									list.css("display","none");
									var arr = $(this).attr("id").split(",");
									startLayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(arr[1], arr[2]).transform("EPSG:4326","EPSG:3857"), iconstart));
									maplet.setCenter(new SuperMap.LonLat(arr[1], arr[2]).transform("EPSG:4326","EPSG:3857"), 12);
									});
								   
	                            }
	                        }
	                    }
                    }
                }
	}
	function processFailed(result) {
	  alert(result);
	}
	return nameList;
}

function findEndStopsOld(endName) {
	mapClear();
	if(isStartKey) return;
    markerlayer.clearMarkers();
	endLayer.clearMarkers();
	vectorLayer.removeAllFeatures();
    var nameList=new Array();
	var list=$("#zhongdian");
	list.empty();;
	
	var params = new SuperMap.REST.StopQueryParameters({
	keyWord: endName,
	returnPosition: true
	});
	var iserver = new SuperMap.REST.StopQueryService(traffic_transfer, {
	eventListeners: {
	processCompleted: stopQuerySucceed,
	processFailed: stopQueryFailed
	}
	});
	iserver.processAsync(params);
	//返回根据模糊的地名搜索得到的跟地名有关的所有公交站点的结果
	function stopQuerySucceed(stopQueryEvent) {
	if(!stopQueryEvent.result.transferStopInfos.length) {
	$("<li>未找到匹配的站点</li>").appendTo(list);
	noStart = true;
	}else {
	noStart = false;
		for(var i=0,len=stopQueryEvent.result.transferStopInfos.length; i<len; i++) {
			var station = stopQueryEvent.result.transferStopInfos[i];
			var value = station.stopID+","+station.position.x+","+station.position.y;
		    list.css("display","block");
			$("<li id='" + value + "'>" + station.name + "</li>").appendTo(list); 
			
			list.find("li").click(function() {
				var input = $("#endName");
				input.val($(this).text());
				input.attr("text", $(this).attr("id"));
				$("#zhongdian").empty();
				list.css("display","none");
				var arr = $(this).attr("id").split(",");
				startLayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(arr[1], arr[2]), iconend));
				maplet.setCenter(new SuperMap.LonLat(arr[1], arr[2]), 4);
				});
		}
	}
	}
	function stopQueryFailed(result) {
	  alert(result);
	}
	return nameList;
}


function findEndStops(endName) {
	mapClear();
	if(isStartKey) return;
    markerlayer.clearMarkers();
	endLayer.clearMarkers();
	vectorLayer.removeAllFeatures();
    var nameList=new Array();
	var list=$("#zhongdian");
	list.empty();;
	
	var queryParam = new SuperMap.REST.FilterParameter({
                    name:"QueryData@海口",
                    attributeFilter: "NAME like  '%"+endName+"%' "
                  });
    var  queryBySQLParams = new SuperMap.REST.QueryBySQLParameters({
        expectCount:10,
        queryParams: [queryParam]
    });
    
    var queryBySQLService = new SuperMap.REST.QueryBySQLService(url, {
                    eventListeners: {"processCompleted": processCompleted, "processFailed": processFailed}});
    queryBySQLService.processAsync(queryBySQLParams);
    
	//返回根据模糊的地名搜索得到的跟地名有关的所有公交站点的结果
	function processCompleted(queryEventArgs) {
	            var i, j, feature,labelFeas = [],label,
                        result = queryEventArgs.result;
                if (result && result.recordsets) {
                    var totalnum=result.currentCount;
                    if(totalnum==0){
                       $("<li>未找到匹配的站点</li>").appendTo(list);
	                   noStart = true;
                    }else{
                        noStart = false;
	                    var pois=new Array(); 
	                    for (i=0; i<result.recordsets.length; i++) {
	                        if (result.recordsets[i].features) {
	                            for (j=0; j<result.recordsets[i].features.length; j++) {
	                               feature = result.recordsets[i].features[j];
	                               pois.push(feature);
	                               var point = feature.geometry;
	                               var icon=getMarkerIcon();
								   var smId=feature.attributes.SmID;
								   var poiName=feature.attributes.NAME;
								   var poiAddress=feature.attributes.ADDRESS;
								   var lon=feature.attributes.SmX;
								   var lat=feature.attributes.SmY;
								   var value = smId+","+lon+","+lat;
								   list.css("display","block");
								   $("<li id='" + value + "'>" + poiName + "</li>").appendTo(list); 
								   list.find("li").click(function() {
									var input = $("#endName");
									input.val($(this).text());
									input.attr("text", $(this).attr("id"));
									$("#zhongdian").empty();
									list.css("display","none");
									var arr = $(this).attr("id").split(",");
									endLayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(arr[1], arr[2]).transform("EPSG:4326","EPSG:3857"), iconend));
									maplet.setCenter(new SuperMap.LonLat(arr[1], arr[2]).transform("EPSG:4326","EPSG:3857"), 12);
									});
								   
	                            }
	                        }
	                    }
                    }
                }
	}
	function processFailed(result) {
	  alert(result);
	}
	return nameList;
}


function getStartEndStopID() {
	if(!$("#startName").attr("value")) {
	alert("查询提示:"+"请选择查询的起点");
	return;
	}
	if(!$("#endName").attr("value")) {
	alert("查询提示:"+"请选择查询的终点");
	return;
	}
	
	var start = $("#startName").attr("text");
	var startList = $("#qidian li");
	if(startList.length === 1 && startList.html() !== "未找到匹配的起点") {
	$("#startName").attr("text", startList.attr("id"));
	$("#startName").attr("value", startList.html());
	start = startList.attr("id").split(",")[0];
	} else {
	if(start) {
	start = parseInt(start.split(",")[0]);
	} else {
	var startStop = $("#qidian").find("li")[0];
	var startStopID = startStop.getAttribute("id");
	var startStopName = startStop.innerHTML;
	if(!startStopID) {
	alert("查询提示:"+"无匹配的起点信息");
	return;
	}
	$("#startName").attr("text", startStopID);
	$("#startName").attr("value", startStopName);
	start = parseInt(startStopID.split(",")[0]);
	}
	}
	var end = $("#endName").attr("text");
	var endList = $("#zhongdian li");
	if(endList.length === 1 && endList.html() !== "未找到匹配的终点") {
	$("#endName").attr("text", endList.attr("id"));
	$("#endName").attr("value", endList.html());
	end = endList.attr("id").split(",")[0];
	} else {
	if(end) {
	end = parseInt(end.split(",")[0]);
	} else {
	var endStop = $("#zhongdian").find("li")[0];
	var endStopID = endStop.getAttribute("id");
	var endStopName = endStop.innerHTML;
	if(!endStopID) {
	alert("查询提示:"+"无匹配的终点信息");
	return;
	}
	$("#endName").attr("text", endStopID);
	$("#endName").attr("value", endStopName);
	end = parseInt(endStopID.split(",")[0]);
	}
	}
	$("#qidian").empty();
	$("#zhongdian").empty();
	return [start, end];
}


function getStartEndStopLonlat() {
	if(!$("#startName").attr("value")) {
	alert("查询提示:"+"请选择查询的起点");
	return;
	}
	if(!$("#endName").attr("value")) {
	alert("查询提示:"+"请选择查询的终点");
	return;
	}
	
	var start = $("#startName").attr("text");
	var startList = $("#qidian li");
	if(startList.length === 1 && startList.html() !== "未找到匹配的起点") {
	$("#startName").attr("text", startList.attr("id"));
	$("#startName").attr("value", startList.html());
	start="{'x':"+startList.attr("id").split(",")[1]+",'y':"+startList.attr("id").split(",")[2]+"}";
	} else {
	if(start) {
	 	start='{"x":'+start.split(",")[1]+',"y":'+start.split(",")[2]+'}';
	} else {
	var startStop = $("#qidian").find("li")[0];
	var startStopID = startStop.getAttribute("id");
	var startStopName = startStop.innerHTML;
	if(!startStopID) {
	alert("查询提示:"+"无匹配的起点信息");
	return;
	}
	$("#startName").attr("text", startStopID);
	$("#startName").attr("value", startStopName);
	start="{'x':"+startStopID.split(",")[1]+",'y':"+startStopID.split(",")[2]+"}";
	}
	}
	var end = $("#endName").attr("text");
	var endList = $("#zhongdian li");
	if(endList.length === 1 && endList.html() !== "未找到匹配的终点") {
	$("#endName").attr("text", endList.attr("id"));
	$("#endName").attr("value", endList.html());
	end="{'x':"+endList.attr("id").split(",")[1]+",'y':"+endList.attr("id").split(",")[2]+"}";
	} else {
	if(end) {
		//end="{'x':"+end.split(",")[1]+",'y':"+end.split(",")[2]+"}";
			 	end='{"x":'+end.split(",")[1]+',"y":'+end.split(",")[2]+'}';
		
	} else {
	var endStop = $("#zhongdian").find("li")[0];
	var endStopID = endStop.getAttribute("id");
	var endStopName = endStop.innerHTML;
	if(!endStopID) {
	alert("查询提示:"+"无匹配的终点信息");
	return;
	}
	$("#endName").attr("text", endStopID);
	$("#endName").attr("value", endStopName);
    end="{'x':"+endStopID.split(",")[1]+",'y':"+endStopID.split(",")[2]+"}";
	}
	}
	$("#qidian").empty();
	$("#zhongdian").empty();
	return [start, end];
}


function getTansferDistance(pointArray,tranLines,dictIndex){
                var params = new SuperMap.REST.TransferPathParameters({
				points: pointArray,
				transferLines: tranLines
				});
				var iserver = new SuperMap.REST.TransferPathService(traffic_transfer, {
				eventListeners: {
				processCompleted: transferPathSucceed
				}
				});
				iserver.processAsync(params);
				var distance=0;
				function transferPathSucceed(event) {
					var transGuide = event.result.transferGuide;
				    distance=parseFloat(transGuide.totalDistance/1000).toFixed(2);
				    var costTime=0;
				   if(transGuide && transGuide.items.length) {
					var items = transGuide.items;
					for(var itemIndex=0, itemLen=items.length; itemIndex<itemLen; itemIndex++) {
						if(items[itemIndex].isWalking){
						  costTime+=((items[itemIndex].distance/1000)/5)*60;
						}else{
						  costTime+=((items[itemIndex].distance/1000)/20)*60;
						}
					}
					}
				    $("#costTime"+dictIndex).html(parseInt(costTime));
				    $("#distanceId"+dictIndex).html(distance);
				}
}


//定义公交换乘，points表示起始点坐标，transferTactic表示换乘策略类型
//包括时间最短、距离最短、最少换乘、最少步行四种选择
function executeTrafficTransfer(points, transferTactic) {
	try{vectorLayer.removeAllFeatures();}catch(e){}
	try{
		globalPaths["points"]=points;
		execTransSolutionsQuery(points, transferTactic, "NONE");
	}catch(e){}
}

function execTransSolutionsQuery(points, tactic, preference, chked) {
	//配置公交换乘参数
	var params = new SuperMap.REST.TransferSolutionParameters({
		solutionCount: 5,//最大换乘导引数量
		transferTactic: tactic,//公交换乘策略类型
		transferPreference: preference,
		walkingRatio: 10,//步行与公交的消耗权重比
		points: points //起始点坐标
	});
	// 配置公交换乘服务,监听两个事件，processCompleted和processFailed,服务端成功返回查询结果时触发
	//processCompleted 事件，服务端返回查询结果失败时触发 processFailed 事件。
	var iserver = new SuperMap.REST.TransferSolutionService(traffic_transfer, {
		eventListeners: {
			processCompleted: transferSolutionsSucceed,
			processFailed: transferSolutionsFailed
		}
	});
	//execute
	iserver.processAsync(params);
	//执行公交换乘成功返回结果
	function transferSolutionsSucceed(event) {
		 //在地图上叠加符号信息
		 var transGuide = event.result.transferGuide,
		 transSolutions = event.result.solutionItems,
		 Solutions = [];
		 for(var j=0; j<transSolutions.length; j++) {
			 var linesItems = transSolutions[j].linesItems, transSolution = [];
			 for(var jj=0;jj<linesItems.length; jj++) {
				 var lineItems = linesItems[jj].lineItems, items = [];
				 for(var jjj=0; jjj<lineItems.length; jjj++) {
					 var lineItem = lineItems[jjj];
					 items.push("{'lineID':" + lineItem.lineID + ",'startStopIndex':" + lineItem.startStopIndex + ",'endStopIndex':" + lineItem.endStopIndex + "}");
				 }
				 transSolution.push(items);
			 }
		     Solutions.push(transSolution);
		 }
		 globalPaths["transSolutions"] = transSolutions;
	     globalPaths["solutions"] = Solutions;
		 var time="";
	     $("#showBusRoutes").html("");
	     var busRoutesHtml = '<tr class="busRoutes"><td style="float: left; margin-left: 10px;"></td></tr>';
	     if(!transGuide || !transSolutions) {
	    	 try{markerlayer.clearMarkers();}catch(e){}
	    	 busRoutesHtml ='<div>'+
	    	 '<div style="background-color:#38B0DE;font-weight:bold;" align="right">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>'+
	    	 '<div align="center" style="color:red;">起始终止位置太近，推荐步行。</div>'+
	    	 '</div>';
	    	 $("#showBusRoutes").append(busRoutesHtml);
	    	 return;
		 }
	     if(transSolutions!=null){
	    	 try{
	    		 markerlayer.clearMarkers();
	 	         startLayer.clearMarkers();
	 	         endLayer.clearMarkers();
	    	}catch(e){}
			for(var i=0,iLen=transSolutions.length; i<iLen; i++) {
				solution = transSolutions[i];
				var title = "";
				var stationCount=0, priceCount=0, tempPrice=0;
				for(var ii=0,iiLen=solution.linesItems.length; ii<iiLen; ii++) {
					lines = solution.linesItems[ii];
					for(var iii=0,iiiLen=lines.lineItems.length; iii<iiiLen; iii++) {
						line = lines.lineItems[iii];
						if(iii == 0)tempPrice=getLinePrice(line.lineName);
						if(iii !== iiiLen-1) {
							title += changeLinename(line.lineName) + "/";
							stationCount+=line.endStopIndex-line.startStopIndex+1;
						} else {
							title += changeLinename(line.lineName);
							stationCount+=line.endStopIndex-line.startStopIndex+1;
						}
					}
					if(ii !== iiLen-1) {
						title += " → ";
						priceCount+=Number(tempPrice);
					}
				}
				priceCount+=Number(tempPrice);
				var pricestr= priceCount==0?'':('/ ' + priceCount + '元');
				//存放默认路径,默认取数组的第一个元素
				var path = "[", pLine;
				var pathLines = solution.linesItems;
				for(var pi=0,pLen=pathLines.length; pi<pLen; pi++) {
					pLine = pathLines[pi].lineItems[0];
					path += "{'lineID':" + pLine.lineID + ",'startStopIndex':" + pLine.startStopIndex + ",'endStopIndex':" + pLine.endStopIndex + "}";
					if(pi !== pLen-1) path += ",";
				}
				path += "]";
				var index = "solutions_" + i;
				globalPaths[index] = path;
				getTansferDistance(globalPaths["points"],globalPaths[index],i);
		        busRoutesHtml +=
				'<tr class="busRoutes">' +
		        '    <td align="center" >' +
		        '        <table width="100%" border="0" cellpadding="0" cellspacing="0" class="bk6 routeTable" id="' + i + '">' +
		        '            <tr class="routetitle bk5"  id="' + i + '" style= "cursor:pointer;" >' +
		        '                <td width="35" height="50" align="center" class="bk4" style="padding-bottom:25px">' +
		        '                    <img src="../images/supermap/icon' + (i + 1) + '.png" width="19" height="18" />' +
		        '                </td>' +
		        '                <td class="bk4" style="padding-bottom:10px">' +
		        '                    <span class="STYLE9" style="line-height:250%">' + title + '</span>' +
		        '                    <br>' +
                '                    <span class="STYLE10">全程约'+'<span id="costTime'+i+'"></span>' + '分钟 /' +'<span id="distanceId'+i+'"></span>'+ '公里 / ' + stationCount + '站'+pricestr+'</span>' +
		        '                </td>' +
		        '            </tr>' +
		        '        </table>' +
		        '    </td>' +
		        ' </tr>';
		        
		     }
      }else{
		busRoutesHtml ='<div>'+
		'<div style="background-color:#38B0DE;font-weight:bold;" align="right">共0条记录&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>'+
		'<div align="center">在<span style="font-weight:bold;">海口市</span>范围内未找到相关线路，抱歉。</div>'+
		'</div>';
	  }
      $("#showBusRoutes").append(busRoutesHtml);	
}
//执行公交换乘失败返回结果
function transferSolutionsFailed(event) {
	var busRoutesHtml ='<div>'+
			'<div style="background-color:#38B0DE;font-weight:bold;" align="right">共0条记录&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>'+
			'<div align="center">在<span style="font-weight:bold;">海口市</span>范围内未找到相关线路，抱歉。</div>'+
			'</div>';
	$("#showBusRoutes").html(busRoutesHtml);
	}
}
function changeLinename(str){//92#92路#0#国兴大道#永和花园#06:30#21:00#2
	var strr = str.split('#');
	if(strr.length==1){
		return strr[0].replace(/((A|B)*$)/g,"");
	}else{
		return strr[1];
		//return strr[1]+'(开往:'+strr[4]+')';
	}
}
function getLinePrice(str){//92#92路#0#国兴大道#永和花园#06:30#21:00#2
	var strr = str.split('#');
	if(strr.length==1){
		return 0;
	}else{
		return strr[7];
	}
}
function rtrimab(str){ //删除右边的A/B
　　 	return str.replace(/((A|B)*$)/g,"");
　　 } 

function execTransPathQuery(id, transLines) {
	var params = new SuperMap.REST.TransferPathParameters({
	points: globalPaths["points"],
	transferLines: transLines
	});
	var iserver = new SuperMap.REST.TransferPathService(traffic_transfer, {
	eventListeners: {
	processCompleted: transferPathSucceed,
	processFailed: transferPathFailed
	}
	});
	iserver.processAsync(params);
	function transferPathSucceed(event) {
		var transGuide = event.result.transferGuide;
		transSolutions = globalPaths["transSolutions"];
		var htmlstr=fillTransferInfo(transGuide, transSolutions, id);
		$(".routeTable").eq(id).append(htmlstr);
	}
	function transferPathFailed(event) {
	
	}
}

//transGuide代表换乘方式，transSolutions代表换乘方案，indexX代表方案索引号
function fillTransferInfo(transGuide, transSolutions, indexX) {
	try{
		markerlayer.clearMarkers();
		startLayer.clearMarkers();
		vectorLayer.removeAllFeatures();
	}catch(e){}
	if(transGuide && transGuide.items.length) {
	var items = transGuide.items;
	var distance=0;
	var costTime=0;
	for(var itemIndex=0, itemLen=items.length; itemIndex<itemLen; itemIndex++) {
		if(items[itemIndex].isWalking){
		   var feature = new SuperMap.Feature.Vector();
		   feature.geometry = items[itemIndex].route.transform("EPSG:4326","EPSG:3857");
		   feature.style = walkStyleLine;
		   vectorLayer.addFeatures(feature);
		}else{
		   var feature = new SuperMap.Feature.Vector();
		   feature.geometry = items[itemIndex].route.transform("EPSG:4326","EPSG:3857");
		   feature.style = busStyleLine;
		   vectorLayer.addFeatures(feature);
		}
	}
	markerlayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(items[0].startPosition.x, items[0].startPosition.y).transform("EPSG:4326","EPSG:3857"), iconstart));
	markerlayer.addMarker(new SuperMap.Marker(new SuperMap.LonLat(items[items.length-1].endPosition.x, items[items.length-1].endPosition.y).transform("EPSG:4326","EPSG:3857"), iconend));
	}
	var pos=indexX;
	// 展开路线详情
	var detailHtmlHead = 
             '<tr class="detail">' +
             '  <td align="center" class="bk3"><img src="../images/supermap/qi.png" width="19" height="23"></td>' +
             '  <td height="35" class="bk3"><span class="STYLE8">' + $("#startName").val() + '&nbsp;<input type="button" value="发送短信" id="sendSms" pos="' + pos + '">&nbsp;<input type="button" value="添加收藏" id="addFavorite" pos="' + pos + '"></span></td>' +
             '</tr>';
    var smsMessage="";         
    var detailHtmlBody = "";
    var indexY = 0;
    for(var iiii=0,iiiiLen=transGuide.items.length; iiii<iiiiLen; iiii++) {
		var item = transGuide.items[iiii];
	if(item.isWalking) {
	    if(iiii!=iiiiLen-1){
		  detailHtmlBody+='<tr class="detail">' +
	             '  <td align="center" class="bk3" ><img src="../images/supermap/icon2.gif" width="18" height="21"></td>' +
	             '  <td height="35" class="bk3" >步行'+parseInt(item.distance)+'米到 <span class="STYLE3" onclick="toStation('+'&quot;'+item.endStopName+'&quot;'+')">' + item.endStopName + '</span>　　　　　　　　　　　<span class="STYLE7"></span><br>' +
	             '    </td>' +
	             '</tr>';
	      smsMessage+="步行"+parseInt(item.distance)+"米到"+item.endStopName+",";   
	     }else{
	     detailHtmlBody+='<tr class="detail">' +
	             '  <td align="center" class="bk3" ><img src="../images/supermap/icon2.gif" width="18" height="21"></td>' +
	             '  <td height="35" class="bk3" >步行'+parseInt(item.distance)+'米到 <span class="STYLE3" onclick="toStation('+'&quot;'+$("#endName").val()+'&quot;'+')">' + $("#endName").val() + '</span>　　　　　　　　　　　<span class="STYLE7"></span><br>' +
	             '    </td>' +
	             '</tr>';
	      smsMessage+="步行"+parseInt(item.distance)+"米到"+$("#endName").val();  
	     }    
	             
	} else {
		var otherLines = transSolutions[indexX].linesItems[indexY];
		var otherMs="";
		var smsMessageother="";
		if(otherLines && otherLines.lineItems.length > 1) {
		for(var oti=0,otLen=otherLines.lineItems.length; oti<otLen; oti++) {
		var line = otherLines.lineItems[oti];
		if(item.lineName !== line.lineName) {
//		detailHtmlBody += 
//		              '<tr class="detail">' +
//		              '  <td align="center" class="bk3"><img src="../images/supermap/icon3.gif" width="16" height="18"></td>' +
//		              '  <td height="35" class="bk3"><span class="STYLE5"  onclick="tobusRoute('+'&quot;'+line.lineName+'&quot;'+')">' + line.lineName + '</span></td>' +
//		              '</tr>';
                      otherMs+='/<span class="STYLE5"  onclick="tobusRoute('+'&quot;'+line.lineName+'&quot;'+')">' + line.lineName + '</span>';
		              smsMessageother+="/"+line.lineName; 
		}
		}
		}
		
		
		
		var points = item.route.components, pointStr = "";
		for(var i=0; i<points.length; i++) {
		pointStr += points[i].x + " " +points[i].y;
		if(i != points.length - 1) {
		pointStr += ",";
		}
		}
		detailHtmlBody += 
		              '<tr class="detail">' +
		              '  <td align="center" class="bk3"><img src="../images/supermap/icon3.gif" width="16" height="18"></td>' +
		              '  <td height="35" class="bk3">乘坐 <span class="STYLE5"  onclick="tobusRoute('+'&quot;'+item.lineName+'&quot;'+')">' + item.lineName + '</span>'+otherMs+',到 <span class="STYLE3" onclick="toStation('+'&quot;'+item.endStopName+'&quot;'+')">' + item.endStopName + '</span> 下车　　　&nbsp;<a class="STYLE7" href="javascript:showStation(&quot;'+item.lineName+'&quot;,&quot;'+item.startStopName+'&quot;,&quot;'+item.endStopName+'&quot;,&quot;'+item.passStopCount+'&quot;);">经' + item.passStopCount + '站</a></td>' +
		              '</tr>';
		              smsMessage+="乘坐"+item.lineName+smsMessageother+"经"+item.passStopCount+"站到"+item.endStopName+"下车,";
		indexY ++;
		}
	}
	globalBusTransMessage[indexX]=smsMessage;   
	var detailHtmlFoot = 
              '<tr class="detail">' +
              '  <td align="center" bgcolor="#F0F5FB"><img src="../images/supermap/zhong.png" width="18" height="23"></td>' +
              '  <td height="35" bgcolor="#F0F5FB"><span class="STYLE8" onclick="toStation('+'&quot;'+$("#endName").val()+'&quot;'+')">' + $("#endName").val() + '</span></td>' +
              '</tr>';      
    var detailHtml = detailHtmlHead + detailHtmlBody+detailHtmlFoot;
    return detailHtml;
}


function showQidian(){
		    $("#zhongdian").css("display","none");	
		    if($("#qidian").css("display")== "none"){
		      $("#qidian").css("display","block");
		      $("#qidian").empty();
		      var str="";
		      $. ajax({
		            url : "bus_route!ajaxlocationlist.action",
					type : "post",
					dataType : "json",
					async:false,
					contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
					success : function(data) {
						if(data.favoriteList==""){
						  str+="<li style='list-style:none;float:left;padding-top:5px;padding-left:5px'><font color='#B3B3B3'>我的家</font></li>"+
						          "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:setAddress(\"set\",\" \");'>设置</a></li>";
						  str+= "<li style='list-style:none;padding-left:5px;padding-top:10px;float:left'><img src='../template/cms/images/qi.gif'><a href='javascript:setAddress(\"add\");'>&nbsp;设置常用地点</a></li>";
						  $("#qidian").append(str);
						}else{
					     for(var i=0;i<data.favoriteList.length;i++){
					        str+="<li onclick='selectstart(\""+data.favoriteList[i].startName+"\")' style='width:70px;list-style:none;float:left;padding-top:5px;padding-left:5px'><font color='#B3B3B3'>"+data.favoriteList[i].customName+"</font></li>"+
					             "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:deleteCommonlyAddress(\""+data.favoriteList[i].id+"\");'>删除</a></li>"+
					             "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:setAddress(\"modify\",\""+data.favoriteList[i].id+"\");'>修改</a></li>";
					     }
					      str+= "<li style='list-style:none;padding-left:5px;padding-top:10px;float:left'><img src='../template/cms/images/qi.gif'><a href='javascript:setAddress(\"add\");'>&nbsp;设置常用地点</a></li>";
					      $("#qidian").append(str);
					    }
		            }
		        });
			}else{
			        $("#qidian").css("display","none");	
				     if($("#zhongdian").css("display")== "block")
				      $("#zhongdian").css("display","none");
			}
}
function showZhongdian(){
		$("#qidian").css("display","none");	
		    if($("#zhongdian").css("display")== "none"){
		        $("#zhongdian").css("display","block");
		         $("#zhongdian").empty();
			      var str="";
			      $. ajax({
			            url : "bus_route!ajaxlocationlist.action",
						type : "post",
						dataType : "json",
						async:false,
						contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
						success : function(data) {
							if(data.favoriteList==""){
							  str+="<li style='list-style:none;float:left;padding-top:5px;padding-left:5px'><font color='#B3B3B3'>我的家</font></li>"+
							          "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:setAddress(\"set\",\" \");'>设置</a></li>";
							  str+= "<li style='list-style:none;padding-left:5px;padding-top:10px;float:left'><img src='../template/cms/images/qi.gif'><a href='javascript:setAddress(\"add\");'>&nbsp;设置常用地点</a></li>";
							  $("#zhongdian").append(str);
							}else{
						     for(var i=0;i<data.favoriteList.length;i++){
						        str+="<li onclick='selectend(\""+data.favoriteList[i].startName+"\")' style='width:70px;list-style:none;float:left;padding-top:5px;padding-left:5px'><font color='#B3B3B3'>"+data.favoriteList[i].customName+"</font></li>"+
						             "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:deleteCommonlyAddress(\""+data.favoriteList[i].id+"\");'>删除</a></li>"+
						             "<li style='list-style:none;float:right;padding-top:5px;padding-right:5px'><a href='javascript:setAddress(\"modify\",\""+data.favoriteList[i].id+"\");'>修改</a></li>";
						     }
						      str+= "<li style='list-style:none;padding-left:5px;padding-top:10px;float:left'><img src='../template/cms/images/qi.gif'><a href='javascript:setAddress(\"add\");'>&nbsp;设置常用地点</a></li>";
						      $("#zhongdian").append(str);
						    }
			            }
			        });
			}else{
				$("#zhongdian").css("display","none");	
			   if($("#qidian").css("display")== "block")
			     $("#qidian").css("display","none");
			 }
}	
		
function showStation(lineName,startStopName,endStopName,passStopCount){
  var label,labelFeas=[];
  $. ajax({
         url : "bus_route!ajaxSearchLineStation.action",
	     type : "post",
	     dataType : "json",
	     data : {lineName:lineName,startName:startStopName,endName:endStopName,passStopCount:passStopCount},
	     async:false,
         contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
	     success : function(data) {
	        var stationPois=data.linePois;
	        for(var i=0;i<stationPois.length;i++){
	                var stationPoi = stationPois[i];
					var infotitle = getInfoWinTitleBs(stationPoi.name);
					var infocontent = getInfoWinContentBs('infocontent'+i, stationPoi.name, lineName, '');
					var size = new SuperMap.Size(10, 10);
	                var offset = new SuperMap.Pixel(-(size.w/2), -size.h);
					var icon=new SuperMap.Icon("../images/supermap/circle.png", size, offset);
					var stationPoiTrans=new SuperMap.LonLat(stationPoi.lon,stationPoi.lat).transform("EPSG:4326","EPSG:3857");
					var marker=new SuperMap.Marker(stationPoiTrans, icon);
				    marker.title=infotitle;
				    marker.content=infocontent;
				    markerlayer.addMarker(marker);
				    marker.events.on({
						      "click":openInfoWin,
						      "scope": marker
				    });
				    label = new SuperMap.Geometry.GeoText(stationPoiTrans.lon,stationPoiTrans.lat, stationPoi.name);
				    labelFeas.push(new SuperMap.Feature.Vector(label));
	        }
	        vectorLayer.addFeatures(labelFeas);
         }
   });
}


function showStation(lineName,startStopName,endStopName,passStopCount){

}


$(function() {

   init("myMap");
   
   
   if (globalRedirect == "nearPoi") {
		$("#poiType").val(decodeURI(decodeURI(globalPoiType)));
        queryPoi(decodeURI(decodeURI(globalPoiType)));
	}
   
   // 点击查询按钮,搜索查询
	$("#searchNearPois").click(function() {
		var poiType = $("#poiType").val();
		queryPoi(poiType);
	});
	
	// 点击查询按钮,查询视野内信息
   $("#synssbutton").click(function() {
        if($("#synsstext").val()!=null&&$("#synsstext").val()!="")
		querySynssPoi($("#synsstext").val());
   });
   


	var myMarkers = new Array();//公交站点地图标点集合
	var $currpoi="";//当前点击站点对象
	var $currbusline="";//当前选中线路对象
	
	// 点击中间的交换按钮时
	$("#exchange").click(function() {
		var temp = $("#startName").val();
		$("#startName").val($("#endName").val());
		$("#endName").val(temp);
	});
	
	$("#printbt").click(function() {
	});
	
	
	
	/**
	 * 当点击一个线路时
	 */
	$(".routeTable .routetitle").livequery("click", function() {	
		// 先将所有的线路的背景变为白色
		$(".routeTable").each(function() {
			$(this).css({"background": "white"});
		});
		// 将点击的这个线路的变量变色并且删除其中间子元素
		$(".detail").empty();
		$(this).css({"background": "#F4F4FA"});
		
		var pos = $(this).attr("id");
	    var transLines = globalPaths["solutions_" + pos];
	    execTransPathQuery(pos, transLines);
	});

	// 点击"查"按钮,查询公交路线
	$("#searchBusRoutes").click(function() {
		if (!globalIsAuto) { // 如果不是从其他页面传过来而触发的,则清空各种全局变量
			globalRedirect = "";
			globalStartName = "";
			globalEndName = "";
			globalLineName = "";
			
			globalPoiType = "";
			globalLinePosition = "";
			globalFrom = "";
		}
		searchBusRoutesFunc();
	});

	// 如果是由首页传过来的,则直接进行查询,支持站点和线路查询
	if (globalRedirect == "busRoute") {
		if (globalLineName != "") {//线路查询
			$("#lineName").val(decodeURI(decodeURI(globalLineName)));
			globalIsAuto = true;
			$("#lineSearch").click();
			$("#searchBusLinesInput").show();
			$("#searchBusRoutesInput").hide();
			$("#showBusRoutes").html("");
			$("#hcfstd").hide();
			mapClear();
			searchBusLinesFunc();
			globalIsAuto = false;
		}else if (globalStationName != "") {//站点查询
			$("#stationName").val(decodeURI(decodeURI(globalStationName)));
			globalIsAuto = true;
			$("#stationSearch").click();
			$("#searchBusStationsInput").show();
			$("#searchBusLinesInput").hide();
			$("#searchBusRoutesInput").hide();
			$("#hcfstd").hide();
			mapClear();
			searchBusStationsFunc();
		    globalIsAuto = false;
		} else {//站点换乘
			$("#startName").val(decodeURI(decodeURI(globalStartName)));
			$("#endName").val(decodeURI(decodeURI(globalEndName)));
			findStartStops(decodeURI(decodeURI(globalStartName)));
	        findEndStops(decodeURI(decodeURI(globalEndName)));
	        $("#hcfstd").show();
			globalIsAuto = true;
			//$("#searchBusRoutes").click();
			globalIsAuto = false;
		}
	}
	
	// 点击最快到达时
	$("#mostFast").click(function() {
		if (routeType != "mostFast") {
			routeType = "mostFast";
			
			//clearPage();
			$("#mostFast").css({"background" : "#47cdf9"}).html("<span class='STYLE1'>最快到达</span>");
			$("#leastChange").css({"background" : "#F0F0F0"}).html("最少换乘");
			$("#leastWalk").css({"background" : "#F0F0F0"}).html("最少步行");
            if($("#busChange").attr("checked")=="checked")
 			$("#searchBusRoutes").click();
		}
	});
	
	// 点击最少换乘时
	$("#leastChange").click(function() {
		if (routeType != "leastChange") {
			routeType = "leastChange";
			
			//clearPage();
			$("#leastChange").css({"background" : "#47cdf9"}).html("<span class='STYLE1'>最少换乘</span>");
			$("#mostFast").css({"background" : "#F0F0F0"}).html("最快到达");
			$("#leastWalk").css({"background" : "#F0F0F0"}).html("最少步行");
            if($("#busChange").attr("checked")=="checked")
			$("#searchBusRoutes").click();
			
		}
	});
	
	// 点击最少步行时
	$("#leastWalk").click(function() {
		if (routeType != "leastWalk") {
			routeType = "leastWalk";
			
			//clearPage();
			$("#leastWalk").css({"background" : "#47cdf9"}).html("<span class='STYLE1'>最少步行</span>");
			$("#mostFast").css({"background" : "#F0F0F0"}).html("最快到达");
			$("#leastChange").css({"background" : "#F0F0F0"}).html("最少换乘");
            if($("#busChange").attr("checked")=="checked")
			$("#searchBusRoutes").click();
		}
	});
	
	// 选择线路查询时
	$("#lineSearch").click(function() {
	    $("#busChange").attr("checked",false);
		$("#searchBusLinesInput").show();
		$("#searchBusRoutesInput").hide();
		$("#searchBusStationsInput").hide();
		$("#hcfstd").hide();
		$("#busScrollbar").css("height","500px")
		$("#showBusRoutes").html("");
		mapClear();
		
	});
	
	// 选择公交换乘时
	$("#busChange").click(function() {
	    $("#busChange").attr("checked",true);
		$("#searchBusLinesInput").hide();
		$("#searchBusStationsInput").hide();
		$("#searchBusRoutesInput").show();
		$("#hcfstd").show();
		$("#busScrollbar").css("height","450px")
		$("#showBusRoutes").html("");
		mapClear();
	});
	
	// 选择站点查询
	$("#stationSearch").click(function() {
		$("#busChange").attr("checked",false);
		$("#searchBusLinesInput").hide();
		$("#searchBusStationsInput").show();
		$("#searchBusRoutesInput").hide();
		$("#showBusRoutes").html("");
		$("#hcfstd").hide();
		$("#busScrollbar").css("height","500px")
		mapClear();
	});

	
	// 点击"查"按钮,查询公交线路站点
	$("#searchBusLines").click(function() {
		searchBusLinesFunc();
	});
	
	// 【线路查询】点击一条具体的公交线路时
	$(".busLine").livequery("click", function() {
		var pos = $(this).attr("pos");
		$(".detail4remove").remove();
		myMarkers = new Array();
		
		if($("#unfold"+pos).attr("class")=='plus'){
		    $("#unfold"+pos).attr("class","minus");
		}else{
		    $("#unfold"+pos).attr("class","plus");
	        return;
		}
		
		$currbusline = $(this);
		var busLineDetail = globalBusLineDetails[pos];
			
		var lineNo = busLineDetail.lineNo;
		var lineType = busLineDetail.busType;
		var busLineDetailHtml ="";
		$.ajax({
			url : "bus_route!ajaxSearchBusLineStation.action",
			type : "post",
			dataType : "json",
			contentType : "application/x-www-form-urlencoded; charset=utf-8", // 防止中文乱码
			data : {
				lineId:lineNo
			},
			success : function(data) {
			    // 在地图上显示这条公交线路
		        // 清除地图上已有折线等叠加物
				mapClear();
				globalBusLineStation = data.busLineStation;
				myMarkers = new Array();
				var stationPois = globalBusLineStation.stationPois;
				var count = stationPois.length;
				for (var i = 0; i < count; i ++) {
				    var yxclHTML="";
				    if(stationPois[i].sfycld!=null&&stationPois[i].sfycld!=""){
				     yxclHTML+='<span style="color:#0181CA">('+stationPois[i].sfycld+')<img width="20px" height="15px" style="margin-bottom:-3px" src="../images/supermap/busyx.png"/></span>';
				    }
					busLineDetailHtml +=
						'<tr class="detail4remove" align="left">' +
						'	<td class="busLineDetailStation"><a class="detailStationc" style="cursor: pointer;" poi="' + i + '">' + (i + 1) + ' ' + stationPois[i].name + '</a>'+yxclHTML+'</td>' +
						'</tr>';
				}
				$("#busLine" + pos).after(busLineDetailHtml);
				//scrollbar.tinyscrollbar_update(parseInt(pos) * 24);
				
				
				
				// 将地图显示为相应的中心和缩放
				
				// 显示线路
				var str = globalBusLineStation.lineLatlons.toString();
				var strArray = str.split(";");
				drawBusLine(strArray);
				var label,labelFeas=[];
//				// 显示站点图标
				for (var j = 0; j < count; j ++) {
					var stationPoi = stationPois[j];
					var infotitle = getInfoWinTitleBs(stationPoi.name);
					var infocontent = getInfoWinContentBs('infocontent'+j, stationPoi.name, globalBusLineStation.routeName, '');
					var size = new SuperMap.Size(10, 10);
	                var offset = new SuperMap.Pixel(-(size.w/2), -size.h);
					var icon=new SuperMap.Icon("../images/supermap/circle.png", size, offset);
					var marker=new SuperMap.Marker(new SuperMap.LonLat(stationPoi.lon,stationPoi.lat).transform("EPSG:4326","EPSG:3857"), icon);
					if((count+1)/2==j){
					   maplet.setCenter(new SuperMap.LonLat(stationPoi.lon,stationPoi.lat).transform("EPSG:4326","EPSG:3857"), maplet.getNumZoomLevels());
					}
					if(j==count/2){
					  maplet.setCenter(new SuperMap.LonLat(stationPoi.lon,stationPoi.lat).transform("EPSG:4326","EPSG:3857"), maplet.getNumZoomLevels());
					}
				    myMarkers.push(marker);
				    marker.title=infotitle;
				    marker.content=infocontent;
				    markerlayer.addMarker(marker);
				    marker.events.on({
						      "click":openInfoWin,
						      "scope": marker
				    });
				    var labelpoint=new SuperMap.LonLat(stationPoi.lon,stationPoi.lat).transform("EPSG:4326","EPSG:3857");
				    label = new SuperMap.Geometry.GeoText(labelpoint.lon,labelpoint.lat, stationPoi.name);
				    labelFeas.push(new SuperMap.Feature.Vector(label));
				}
				vectorLayer.addFeatures(labelFeas);
				
				var busInfos=globalBusLineStation.busInfos;
				var labelFeas = [],label;
				for(var k=0;k<busInfos.length;k++){
				    var size = new SuperMap.Size(18, 15);
	                var offset = new SuperMap.Pixel(-(size.w/2), -size.h);
					var icon=new SuperMap.Icon("../images/supermap/busyx.png", size, offset);
					var busInfo=busInfos[k];
					var marker=new SuperMap.Marker(new SuperMap.LonLat(busInfo.longitude,busInfo.latitude).transform("EPSG:4326","EPSG:3857"), icon);
				    myMarkers.push(marker);
				    markerlayer.addMarker(marker);
				    var labelpoint=new SuperMap.LonLat(busInfo.longitude,busInfo.latitude).transform("EPSG:4326","EPSG:3857");
				    label = new SuperMap.Geometry.GeoText(labelpoint.lon,labelpoint.lat, busInfo.carno);
				    labelFeas.push(new SuperMap.Feature.Vector(label));
				}
				vectorLayer.addFeatures(labelFeas);
				
			}
		});

	});
	
});

function drawBusRouteSuperMapByLu(LineName,Up_down){
   var queryParam, queryBySQLParams, queryBySQLService;
   queryParam = new SuperMap.REST.FilterParameter({
                    name:"BusLine@海口",
                    attributeFilter: "Name =  '"+LineName+"' AND Up_down ='"+Up_down+"'"
   });
   queryBySQLParams = new SuperMap.REST.QueryBySQLParameters({
                    queryParams: [queryParam]
   });
   queryBySQLService = new SuperMap.REST.QueryBySQLService(url, {eventListeners: {"processCompleted": processRouteCompletedCloud, "processFailed": processFailed}});
   queryBySQLService.processAsync(queryBySQLParams);
}
function drawBusRouteFormSuperMap(LineId){
   var queryParam, queryBySQLParams, queryBySQLService;
   queryParam = new SuperMap.REST.FilterParameter({
                    name:"BusLine@海口",
                    attributeFilter: "LineID =  '"+LineId+"'"
   });
   queryBySQLParams = new SuperMap.REST.QueryBySQLParameters({
                    queryParams: [queryParam]
   });
   queryBySQLService = new SuperMap.REST.QueryBySQLService(url, {eventListeners: {"processCompleted": processRouteCompleted, "processFailed": processFailed}});
   queryBySQLService.processAsync(queryBySQLParams);
}

function queryBusRouteStationFormSuperMapByLineId(LineId){
   var queryParam, queryBySQLParams, queryBySQLService;
   queryParam = new SuperMap.REST.FilterParameter({
                    name:"LineStopRelation@海口",
                    attributeFilter: "LineId =  '"+LineId+"'"
   });
   queryBySQLParams = new SuperMap.REST.QueryBySQLParameters({
                    queryParams: [queryParam]
   });
   queryBySQLService = new SuperMap.REST.QueryBySQLService(url, {eventListeners: {"processCompleted": processRouteStationCompleted, "processFailed": processFailed}});
   queryBySQLService.processAsync(queryBySQLParams);
}

function processRouteCompleted(queryEventArgs) {
                var i, j, feature,
                result = queryEventArgs.result;
                if (result && result.recordsets) {
                    for (i=0; i<result.recordsets.length; i++) {
                        if (result.recordsets[i].features) {
                            for (j=0; j<result.recordsets[i].features.length; j++) {
                               feature = result.recordsets[i].features[j];
                               feature.style = busStyleLine;
                               vectorLayer.addFeatures(feature);
                            }
                        }
                    }
                }
}
function processRouteCompletedCloud(queryEventArgs) {
    var i, j, feature,
    result = queryEventArgs.result;
    if (result && result.recordsets) {
    	for (i=0; i<result.recordsets.length; i++) {
            if (result.recordsets[i].features) {
            	if (result.recordsets[i].features.length==0){
                	alert("线路地图数据完善中！");
                }else{
                	for (j=0; j<result.recordsets[i].features.length; j++) {
                        feature = result.recordsets[i].features[j];
                        feature.style = busStyleLine;
                        feature.geometry.transform("EPSG:4326","EPSG:3857");
                        vectorLayer.addFeatures(feature);
                     }
                }
            }
        }
    }
}
function processRouteStationCompleted(queryEventArgs) {
               
}
function processFailed(result) {
	  alert(result);
}

